#pragma once
#include <argp.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

struct arguments{
    double source_x;
    double source_y;
    double goal_x;
    double goal_y;
    char * map_path;
};

static error_t parse_opt (int key, char * arg, struct argp_state * state){
  struct arguments * arguments = state->input;
  switch (key){
    case 'x':
      arguments->source_x = atof(arg);
      break;
    case 'y':
      arguments->source_y = atof(arg);
      break;
    case 'X':
      arguments->goal_x = atof(arg);
      break;
    case 'Y':
      arguments->goal_y = atof(arg);
      break;
    case 'm':
      arguments->map_path = arg;
      break;
    case ARGP_KEY_END:
        if ((arguments->source_x < -1000.0) || (arguments->source_y < -1000.0) || (arguments->goal_x < -1000.0) || (arguments->goal_y < -1000.0) || arguments->map_path == NULL){
            argp_failure(state, 1, 0, "required arguments missing, See --help for more information");
            exit(ARGP_ERR_UNKNOWN);
        }
        break;
    default:
      return ARGP_ERR_UNKNOWN;
    }
  return 0;
}

void initialize_arguments(struct arguments *arguments){
    arguments->source_x = -1001;
    arguments->source_y = -1001;
    arguments->goal_x = -1001;
    arguments->goal_y = -1001;
    arguments->map_path = NULL;
}
