#include <stdio.h>
#include "graph.h"
#include "dijkstra.h"
#include <unistd.h>
#include <stdlib.h>
#include <getopt.h>
/*
UNH CS 758 Assignment 10: Shortest Paths 
Devin Wild Thomas 11/2023

The only thing you need to change is dijkstra_search, while you may modify the rest it should not be necissary to change anything else that is provided.

*/
struct arguments{
    double source_x;
    double source_y;
    double goal_x;
    double goal_y;
    char * map_path;
};

void initialize_arguments(struct arguments *arguments){
    arguments->source_x = -1001;
    arguments->source_y = -1001;
    arguments->goal_x = -1001;
    arguments->goal_y = -1001;
    arguments->map_path = NULL;
}

int main (int argc, char* * argv){
    struct arguments arguments;
    Vertex * source;
    Vertex * goal;
    Graph * g;
    Metadata metadata;
    int opt;

    static struct option long_options[] = {
        {"slon", required_argument, NULL, 'x'},
        {"slat", required_argument, NULL, 'y'},
        {"glon", required_argument, NULL, 'X'},
        {"glat", required_argument, NULL, 'Y'},
        {"map", required_argument, NULL, 'm'},
        {NULL, 0, NULL, 0}
    };
    initialize_arguments(&arguments);
    while ((opt = getopt_long(argc, argv, "x:y:X:Y:m:", long_options, NULL)) != -1) {
        switch (opt) {
            case 'x':
                arguments.source_x = atof(optarg);
                break;
            case 'y':
                arguments.source_y = atof(optarg);
                break;
            case 'X':
                arguments.goal_x = atof(optarg);
                break;
            case 'Y':
                arguments.goal_y = atof(optarg);
                break;
            case 'm':
                arguments.map_path = optarg;
                break;
            default:
                fprintf(stderr, "Usage: %s --slon <source_longitude> --slat <source_latitude> --glon <goal_longitude> --glat <goal_latitude> --map <graph_filepath>\n", argv[0]);
                exit(EXIT_FAILURE);
        }
    }

    if (optind < argc) {
        fprintf(stderr, "Error: Extra arguments provided\n");
        exit(EXIT_FAILURE);
    }
  /*Read Graph File*/
  g = readGraph(arguments.map_path);
  /*Find nearest node to specified start and goal*/
  source = find_nearest(arguments.source_x, arguments.source_y, g);
  goal = find_nearest(arguments.goal_x, arguments.goal_y, g);
  if(source == NULL || goal == NULL){
    fprintf(stderr, "Error: unable to locate goal or source in graph.");
    exit(-1);
  }
  /*Perform Search*/
  metadata = dijkstra_search(source, goal, g);  /* <- You implement this */
  /*Print metadata to stderr*/
  emit_metadata(&metadata, stderr);
  free_graph(g);
  exit (0);
}